﻿' PTIXIAKI ERGASIA
'
' Spiroglou Dimitris
'
' A.T.E.I. KRITIS - TMIMA EFARMOSMENIS PLIROFORIKIS K POLIMESON
'
' Space Shoot'em up project
' Visual Basic .NET Compact Framework
'
' Apagoreuetai i opoiadipote xrisi/anadimosieusi olou i merous tou kodika gia emporikous skopous.
'

Imports System
Imports System.Drawing
Imports System.Drawing.Imaging
Imports System.IO
Imports System.Windows.Forms



Public Class Form1

#Region "Diafores Statheres kai metavlites"

    Shared CUSTOM_LEVEL_MODE As Boolean = True ' Se ti mode (epilogi apo arxiko menu) tha treksei to paixnidi 

    Const MAXIMUMENEMYPERTYPE As Integer = 10 ' Orio antipalon ana tipo
    Const MAXIMUMLASERPERTYPE As Integer = 20 ' Orio tautoxronon laser ana antipalo
    Const NumberOfLevelsCONST As Integer = 3 ' Arithmos ton IDI PROGRAMMATISMENON diaforetikon levels
    Const ProjectName As String = "Ptixiaki" ' To onoma tou project - xrisimopoieitai apo bitmapstreamloader
    Const GameFPS As Integer = 24  ' To refresh rate tou paixnidiou (timer interval = 1000 / GameFPS)
    Const PlayerMaxHealth As Integer = 50 ' Megisti igeia tou paixti
    Const PlayerLaserNum As Integer = 10 ' Arithmos tautoxronon laser tou paikti
    Const EnergyBonus As Integer = 10 ' Posi igeia (energeia) anakta o paiktis apo to energy bonus
    Const EnergyPossibility As Integer = 5 ' Pithanotita na emfanistei bonus 0:katholou 100+:sxedon panta
    Const StarsNum As Integer = 2 ' Arithmos ton megalon asterion sto background
    Const MinStarSpeed As Integer = 2 ' Elaxisti taxitita megalon asterion
    Const MaxStarSpeed As Integer = 5 ' Megisti taxitita megalon asterion
    Const SmallStarsNum As Integer = 15 ' Arithmos ton mikron asterion sto background
    Const MinSmallStarSpeed As Integer = 1 ' Elaxisti taxitita mikron asterion
    Const MaxSmallStarSpeed As Integer = 3 ' Megisti taxitita mikron asterion

    Dim GameCompleted As Boolean = False ' An to paixnidi exei olklirosei tin teleutaia tou pista i oxi
    Shared GameOver As Boolean = False ' An o paiktis exei katastrafei

    Shared bmpDoubleBuffer As Bitmap ' To kirios bitmap tou paixnidiou sto opoio ginetai double buffering

    ' Fortosi genikon grafikon

    Shared CurrentBackground As Bitmap = Form1.BitmapStreamLoader("null.bmp") ' To trexon background
    Dim GameOverBMP As Bitmap = BitmapStreamLoader("GameOver.bmp") ' Game over 
    Dim GameCompletedBMP As Bitmap = BitmapStreamLoader("game_finished.bmp") ' Niki paixnidiou
    Shared MissionAccomplishedBMP As Bitmap = Form1.BitmapStreamLoader("MissionAcc.bmp") ' Niki pistas

    ' Ta parakato xrisimopoiountai kata tin klisi ton constructors
    Dim StarBMP As Bitmap = BitmapStreamLoader("BigStar.bmp")  ' megalo asteri
    Dim SmallStarBMP As Bitmap = BitmapStreamLoader("SmallStar.bmp")  ' mikro asteri
    Dim PlayerLaserBMP As Bitmap = BitmapStreamLoader("Laser0.bmp") ' To laser tou paixti


    ' Ta parakato einai ta grafika tou mikrou status pou fainetai sto kato meros tis othonis
    Shared MissionTextBMP As Bitmap = Form1.BitmapStreamLoader("MissionText.bmp") ' Keimeno "Mission"
    Shared EnergyTextBMP As Bitmap = Form1.BitmapStreamLoader("EnergyText.bmp") ' Keimeno "Energy"
    Shared GreenBar As Bitmap = Form1.BitmapStreamLoader("GreenBar.jpg") ' Green Bar
    Shared BlueBar As Bitmap = Form1.BitmapStreamLoader("BlueBar.bmp") ' Blue Bar
    Shared GreyBar As Bitmap = Form1.BitmapStreamLoader("GreyBar.bmp") ' Grey Bar
    Shared RedBar As Bitmap = Form1.BitmapStreamLoader("RedBar.jpg") ' Green Bar

    ' Diafores metavlites gia ton programmatismo kai elegxo ton diaforon piston tou paixnidiou
    Shared CustomUFOProperties, CustomAlienProperties, CustomMeteoriteProperties As EnemyProperties
    Shared CustomKillsCount As Integer
    Shared CurrentLevel As Integer = 1
    Shared NumberOfLevels As Integer = NumberOfLevelsCONST
    Shared LevelProgress As Integer = 0
    Shared LevelProgressSTEP As Integer = 0

    ' O paiktis kai ta laser tou
    Shared Player As PlayerObject
    Shared PlayerLaserShots(PlayerLaserNum) As PlayerMissile

    ' To bonus energeias
    Shared Energy As BonusObject

    ' Ta asteria mikra kai megala tou background
    Dim BackStars(StarsNum) As StarObject
    Dim BackSmallStars(SmallStarsNum) As StarObject

    ' Edo ginetai i dimiourgia enos random antikeimenou xrisimopoieitai apo ObjRandomizer
    Dim r As Random = New Random() ' De mpainei mesa stin ObjRandomizer gia "kalitera" random apotelesmata

    ' Dimiourgia tou array antikeimenon tipou GameLevel - oi diafores pistes
    Dim GameLevels(NumberOfLevelsCONST) As GameLevel

    ' Poio pliktro patietai/afinetai
    Shared KeyFlag As Integer
    ' Xrisi gia tin kinisi tou paikti apo to pliktrologio
    Enum Directions As Integer
        NullDirection = 0
        GoUp = 1
        GoDown = 2
        GoLeft = 3
        GoRight = 4
        Fire = 5
        NullDirection_FireException = 6
        RESERVED_FUTURE_USE = 7
        GoUpStop = 8
        GoDownStop = 9
        GoLeftStop = 10
        GoRightStop = 11
        FireStop = 12
    End Enum

    ' Xrisi gia ton kathorismo tis katastasis animation ton antikeimenon
    Enum AnimationStatus As Integer
        Normal = 0
        Explosion = 1
        Damage = 2
    End Enum

    ' I domi pano stin opoia tha programmatistoun oi idiotites ton antikeimenon tou paixnidiou
    Public Structure EnemyProperties
        Dim Enabled As Boolean
        Dim EnemyAnimation() As Bitmap
        Dim EnemyX, EnemyY As Integer
        Dim EnemyMinX, EnemyMinY As Integer
        Dim EnemyMaxX, EnemyMaxY As Integer
        Dim EnemyMinSpeed, EnemyMaxSpeed As Integer
        Dim EnemyAgressiveness As Integer
        Dim EnemyCount As Integer
        Dim EnemyFireNum As Integer
        Dim EnemyLaserDamage As Integer
        Dim EnemyCollisionDamage As Integer
    End Structure

#End Region

#Region "OnPaint Subs kai Double Buffering"

    Protected Overrides Sub OnPaintBackground(ByVal e As System.Windows.Forms.PaintEventArgs)
        ' I parakato entoli prokalei to flickering opote comment-out
        ' MyBase.OnPaintBackground(e)
    End Sub

    Protected Overrides Sub OnPaint(ByVal e As System.Windows.Forms.PaintEventArgs)


        CreateDoubleBuffer()  ' Dimiourgia double buffering bitmap

        e.Graphics.DrawImage(bmpDoubleBuffer, 0, 0) ' Sxediasi tou double buffer stin othoni!

    End Sub

    Private Sub CreateDoubleBuffer()

        If bmpDoubleBuffer Is Nothing Then

            bmpDoubleBuffer = New Bitmap(Me.Width, Me.Height) ' Full Screen buffering
            Dim g As Graphics = Graphics.FromImage(bmpDoubleBuffer) ' kentriko buffer
            g.DrawImage(CurrentBackground, 0, 0)

        End If

    End Sub

#End Region

#Region "Elegxos pliktrologiou (KeyUp/KeyDown)"

    Private Sub Form1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp

        If (e.KeyCode = System.Windows.Forms.Keys.Up) Then
            KeyFlag = Directions.GoUpStop
        End If
        If (e.KeyCode = System.Windows.Forms.Keys.Down) Then
            KeyFlag = Directions.GoDownStop
        End If
        If (e.KeyCode = System.Windows.Forms.Keys.Left) Then
            KeyFlag = Directions.GoLeftStop
        End If
        If (e.KeyCode = System.Windows.Forms.Keys.Right) Then
            KeyFlag = Directions.GoRightStop
        End If
        'If (e.KeyCode = System.Windows.Forms.Keys.Enter) Or (e.KeyCode = System.Windows.Forms.Keys.Space) Then
        'KeyFlag = Directions.FireStop
        'End If

    End Sub

    Private Sub Form1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown

        ' debugging 
        ' MsgBox(e.KeyCode, MsgBoxStyle.OkOnly)

        If (e.KeyCode = System.Windows.Forms.Keys.P) And Panel1.Visible = False Then
            ' PAUSE
            Timer1.Enabled = Not (Timer1.Enabled)
        End If

        If (e.KeyCode = System.Windows.Forms.Keys.Up) Then

            KeyFlag = Directions.GoUp
        End If
        If (e.KeyCode = System.Windows.Forms.Keys.Down) Then

            KeyFlag = Directions.GoDown
        End If
        If (e.KeyCode = System.Windows.Forms.Keys.Left) Then

            KeyFlag = Directions.GoLeft
        End If
        If (e.KeyCode = System.Windows.Forms.Keys.Right) Then

            KeyFlag = Directions.GoRight
        End If
        If (e.KeyCode = System.Windows.Forms.Keys.Enter) Or (e.KeyCode = System.Windows.Forms.Keys.Space) Then
            'Enter
            KeyFlag = Directions.Fire
        End If

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        If Not CUSTOM_LEVEL_MODE Then

            Init()
        Else

            Timer1.Enabled = False

            Panel1.Visible = True

        End If


    End Sub

    Public Sub Init()

        ' Fortosi tou eisagogikou "Splash Screen" tis kathe pistas
        Dim LevelSplashes(4) As Bitmap
        LevelSplashes(0) = BitmapStreamLoader("Level1.bmp")
        LevelSplashes(1) = BitmapStreamLoader("Level2.bmp")
        LevelSplashes(2) = BitmapStreamLoader("Level3.bmp")

        ' Xrisi ton parakato metavliton gia ton programmatismo ton diaforon piston tou paixnidiou
        Dim DefaultUFOProperties, DefaultAlienProperties, DefaultMeteoriteProperties As EnemyProperties
        Dim NullProperties As EnemyProperties

        ' Dilosi ton arrays pou exoun ta frames gia to animation ton antikeimenon
        ' Frames 0-3 Normal katastasi  
        ' Frames 4-7 Explosion katastasi  
        ' Frames 8-11 Damage katastasi

        Dim MeteoriteAnimated(7) As Bitmap ' Meteorites exoun Normal kai Explosion
        MeteoriteAnimated(0) = BitmapStreamLoader("Meteorite0.bmp")
        MeteoriteAnimated(1) = BitmapStreamLoader("Meteorite1.bmp")
        MeteoriteAnimated(2) = BitmapStreamLoader("Meteorite2.bmp")
        MeteoriteAnimated(3) = BitmapStreamLoader("Meteorite3.bmp")
        MeteoriteAnimated(4) = BitmapStreamLoader("MetExpl00.bmp")
        MeteoriteAnimated(5) = BitmapStreamLoader("MetExpl01.bmp")
        MeteoriteAnimated(6) = BitmapStreamLoader("MetExpl02.bmp")
        MeteoriteAnimated(7) = BitmapStreamLoader("MetExpl03.bmp")

        Dim AlienAnimated(7) As Bitmap ' Aliens exoun Normal kai Explosion
        AlienAnimated(0) = BitmapStreamLoader("Alien00.bmp")
        AlienAnimated(1) = BitmapStreamLoader("Alien01.bmp")
        AlienAnimated(2) = BitmapStreamLoader("Alien03.bmp")
        AlienAnimated(3) = BitmapStreamLoader("Alien05.bmp")
        AlienAnimated(4) = BitmapStreamLoader("AlienExpl00.bmp")
        AlienAnimated(5) = BitmapStreamLoader("AlienExpl01.bmp")
        AlienAnimated(6) = BitmapStreamLoader("AlienExpl02.bmp")
        AlienAnimated(7) = BitmapStreamLoader("AlienExpl03.bmp")

        Dim PlayerAnimated(11) As Bitmap ' O paiktis exei Normal, Explosion kai Damage
        PlayerAnimated(0) = BitmapStreamLoader("Spaceship0.bmp")
        PlayerAnimated(1) = BitmapStreamLoader("Spaceship1.bmp")
        PlayerAnimated(2) = BitmapStreamLoader("Spaceship2.bmp")
        PlayerAnimated(3) = BitmapStreamLoader("Spaceship3.bmp")
        PlayerAnimated(4) = BitmapStreamLoader("SpaceshipExp0.bmp")
        PlayerAnimated(5) = BitmapStreamLoader("SpaceshipExp1.bmp")
        PlayerAnimated(6) = BitmapStreamLoader("SpaceshipExp2.bmp")
        PlayerAnimated(7) = BitmapStreamLoader("SpaceshipExp3.bmp")
        PlayerAnimated(8) = BitmapStreamLoader("SpaceshipDamage00.bmp")
        PlayerAnimated(9) = BitmapStreamLoader("SpaceshipDamage01.bmp")
        PlayerAnimated(10) = BitmapStreamLoader("SpaceshipDamage02.bmp")
        PlayerAnimated(11) = BitmapStreamLoader("SpaceshipDamage03.bmp")

        Dim EnergyAnimated(3) As Bitmap ' To bonus enrgeias exei mono Normal
        EnergyAnimated(0) = BitmapStreamLoader("Energy00.bmp")
        EnergyAnimated(1) = BitmapStreamLoader("Energy01.bmp")
        EnergyAnimated(2) = BitmapStreamLoader("Energy02.bmp")
        EnergyAnimated(3) = BitmapStreamLoader("Energy03.bmp")

        Dim UFOAnimated(7) As Bitmap ' Ta UFO exoun Normal kai Explosion
        UFOAnimated(0) = BitmapStreamLoader("UFO00.bmp")
        UFOAnimated(1) = BitmapStreamLoader("UFO01.bmp")
        UFOAnimated(2) = BitmapStreamLoader("UFO02.bmp")
        UFOAnimated(3) = BitmapStreamLoader("UFO03.bmp")
        UFOAnimated(4) = BitmapStreamLoader("UFOEXPL00.bmp")
        UFOAnimated(5) = BitmapStreamLoader("UFOEXPL01.bmp")
        UFOAnimated(6) = BitmapStreamLoader("UFOEXPL02.bmp")
        UFOAnimated(7) = BitmapStreamLoader("UFOEXPL03.bmp")

        ' Null rithmiseis - xrisimes ston constructor ton GameLevels
        NullProperties.Enabled = False



        ' Oi default rithmiseis gia ton exthro tipou "UFO"
        DefaultUFOProperties.Enabled = True
        DefaultUFOProperties.EnemyAgressiveness = 15
        DefaultUFOProperties.EnemyAnimation = UFOAnimated
        DefaultUFOProperties.EnemyCollisionDamage = 10
        DefaultUFOProperties.EnemyCount = 3
        DefaultUFOProperties.EnemyFireNum = 2
        DefaultUFOProperties.EnemyLaserDamage = 5
        DefaultUFOProperties.EnemyMaxSpeed = 3
        DefaultUFOProperties.EnemyMaxX = Me.Width
        DefaultUFOProperties.EnemyMaxY = Me.Height / 2 + UFOAnimated(0).Height
        DefaultUFOProperties.EnemyMinSpeed = 2
        DefaultUFOProperties.EnemyMinX = 0
        DefaultUFOProperties.EnemyMinY = 0
        DefaultUFOProperties.EnemyX = 0
        DefaultUFOProperties.EnemyY = 0

        ' Oi default rithmiseis gia ton exthro tipou "Alien"
        DefaultAlienProperties.Enabled = True
        DefaultAlienProperties.EnemyAgressiveness = 10
        DefaultAlienProperties.EnemyAnimation = AlienAnimated
        DefaultAlienProperties.EnemyCollisionDamage = 10
        DefaultAlienProperties.EnemyCount = 3
        DefaultAlienProperties.EnemyFireNum = 2
        DefaultAlienProperties.EnemyLaserDamage = 5
        DefaultAlienProperties.EnemyMaxSpeed = 5
        DefaultAlienProperties.EnemyMaxX = Me.Width
        DefaultAlienProperties.EnemyMaxY = Me.Height / 2 + AlienAnimated(0).Height
        DefaultAlienProperties.EnemyMinSpeed = 3
        DefaultAlienProperties.EnemyMinX = 0
        DefaultAlienProperties.EnemyMinY = 0
        DefaultAlienProperties.EnemyX = 0
        DefaultAlienProperties.EnemyY = 0

        ' Oi default rithmiseis gia tous meteorites
        DefaultMeteoriteProperties.Enabled = True
        DefaultMeteoriteProperties.EnemyAgressiveness = 0
        DefaultMeteoriteProperties.EnemyAnimation = MeteoriteAnimated
        DefaultMeteoriteProperties.EnemyCollisionDamage = 10
        DefaultMeteoriteProperties.EnemyCount = 3
        DefaultMeteoriteProperties.EnemyFireNum = 0
        DefaultMeteoriteProperties.EnemyLaserDamage = 0
        DefaultMeteoriteProperties.EnemyMaxSpeed = 10
        DefaultMeteoriteProperties.EnemyMaxX = Me.Width
        DefaultMeteoriteProperties.EnemyMaxY = Me.Height
        DefaultMeteoriteProperties.EnemyMinSpeed = 3
        DefaultMeteoriteProperties.EnemyMinX = 0
        DefaultMeteoriteProperties.EnemyMinY = 0
        DefaultMeteoriteProperties.EnemyX = 0
        DefaultMeteoriteProperties.EnemyY = 0

        ' Simplirosi anagkaion timon se periptosi pou to paixnidi treksei se custom level mode
        CustomUFOProperties.EnemyAnimation = DefaultUFOProperties.EnemyAnimation
        CustomAlienProperties.EnemyAnimation = DefaultAlienProperties.EnemyAnimation
        CustomMeteoriteProperties.EnemyAnimation = DefaultMeteoriteProperties.EnemyAnimation


        ' Orismos FPS paixnidiou apo stathera
        Me.Timer1.Interval = (1000 / GameFPS)

        ' Dimiourgia paikti
        Player = New PlayerObject(PlayerAnimated, ((Me.Width / 2) - (PlayerAnimated(0).Width / 2)), ((Me.Height) - (PlayerAnimated(0).Height)), 0, 0, Me.Width, Me.Height - 20, 4, 4)

        ' Dimiourgia megalon asterion...
        For i As Integer = 0 To StarsNum - 1
            BackStars(i) = New StarObject(StarBMP, 0, 0, 0, 0, Me.Width, Me.Height, MinStarSpeed, MaxStarSpeed)
        Next i

        ' ...kai mikron
        For i As Integer = 0 To SmallStarsNum - 1
            BackSmallStars(i) = New StarObject(SmallStarBMP, 0, 0, 0, 0, Me.Width, Me.Height, MinSmallStarSpeed, MaxSmallStarSpeed)
        Next i

        ' Dimiourgia ton laser tou paikti
        For i As Integer = 0 To PlayerLaserNum - 1
            PlayerLaserShots(i) = New PlayerMissile(PlayerLaserBMP, 0, 0, 0, 0, Me.Height, Me.Width, 8, 8)
        Next i

        ' Dimiourgia tou energy bonus
        Energy = New BonusObject(EnergyAnimated, 0, 0, 0, 0, Me.Width, Me.Height, 3, 3)

        If Not CUSTOM_LEVEL_MODE Then

            ' Dimiourgia ton prokathorismenon piston paixnidiou
            GameLevels(0) = New GameLevel(LevelSplashes(0), BitmapStreamLoader("Galaxy1.bmp"), 5, DefaultUFOProperties, NullProperties, DefaultMeteoriteProperties)
            GameLevels(1) = New GameLevel(LevelSplashes(1), BitmapStreamLoader("Galaxy3.bmp"), 10, NullProperties, DefaultAlienProperties, DefaultMeteoriteProperties)
            GameLevels(2) = New GameLevel(LevelSplashes(2), BitmapStreamLoader("Galaxy4.bmp"), 25, DefaultUFOProperties, DefaultAlienProperties, DefaultMeteoriteProperties)
        Else
            ' Dimiourgia tis mias kai monadikis custom pistas...
            GameLevels(0) = New GameLevel(LevelSplashes(0), BitmapStreamLoader("Galaxy1.bmp"), CustomKillsCount, CustomUFOProperties, CustomAlienProperties, CustomMeteoriteProperties)
            NumberOfLevels = 1
            ' ...kai ksekiname!
            Timer1.Enabled = True
        End If


    End Sub

    Public Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        If Not GameOver And Not GameCompleted Then

            ' Leitourgia tis trexousas pistas (Kinisi, sxediasi exthron k.l.p.)
            If CurrentLevel - 1 = NumberOfLevels Then GameCompleted = True Else GameLevels(CurrentLevel - 1).Update()


            ' Metakiniseis antikeimenon kai sxediasi auton

            If Not GameCompleted Then

                ' Asteria megala tou background...
                For i As Integer = 0 To StarsNum - 1
                    BackStars(i).PositionUpdate()
                    BackStars(i).DrawObject()
                Next i

                ' ...kai ta mikra
                For i As Integer = 0 To SmallStarsNum - 1
                    BackSmallStars(i).PositionUpdate()
                    BackSmallStars(i).DrawObject()
                Next i


                ' Kinisi / Sxediasi paikti kai tou status tou
                Player.PositionUpdate()
                Player.DrawObject()
                Player.PlayerStatus()


                ' Kinisi / Sxediasi ton laser tou paikti
                For i As Integer = 0 To PlayerLaserNum - 1
                    PlayerLaserShots(i).PositionUpdate()
                    If PlayerLaserShots(i).IsAlive Then

                        PlayerLaserShots(i).DrawObject()
                    End If
                Next i


            End If

            ' Me auton ton tropo prokaloume tin ektelesi tis OnPaint gia tin sxediasi ton grafikon
            Me.Invalidate()

        Else

            'Edo tha vrethoume otan o paiktis tha exei xasei i tha exei teleiosei to paixnidi
            'Deixnoume to analogo minima...
            If GameOver Then ShowGFXCentered(GameOverBMP) Else ShowGFXCentered(GameCompletedBMP)

            ' Ektelesi OnPaint...
            Me.Invalidate()

            ' Pagoma paixnidiou gia 3 deuterolepta
            FreezeGameForXSeconds(3)

            ' Epanekkinisi paixnidiou stin proti pista. Arxikopoiisi kapoion metavliton elegxou k.a.
            GameOver = False
            GameCompleted = False
            Player.IsAlive = True
            Player.ObjAnimation = AnimationStatus.Normal
            Player.Health = Player.MaxHealth
            For i As Integer = 0 To NumberOfLevels - 1
                GameLevels(i).Init()
                GameLevels(i).InitedOnce = False
            Next
            LevelProgress = 0
            CurrentLevel = 1

        End If

    End Sub

    Shared Sub ShowGFXCentered(ByVal GFX As Bitmap)

        ' Emfanisi enos bitmap kentrarismeno stin othoni

        Dim TransparencyAttr2 As System.Drawing.Imaging.ImageAttributes = New System.Drawing.Imaging.ImageAttributes
        Dim g2 As Graphics = Graphics.FromImage(bmpDoubleBuffer)
        Dim dstRect2 = New Rectangle((Form1.Width / 2) - (GFX.Width / 2), (Form1.Height / 2) - (GFX.Height / 2), GFX.Width, GFX.Height)
        TransparencyAttr2.SetColorKey(Color.Red, Color.Red)
        g2.DrawImage(GFX, dstRect2, 0, 0, GFX.Width, GFX.Height, GraphicsUnit.Pixel, TransparencyAttr2)

    End Sub

    Shared Sub ShowGFXAtXY(ByVal GFX As Bitmap, ByVal ShowX As Integer, ByVal ShowY As Integer)

        ' Emfanisi enos bitmap se simeio X,Y stin othoni

        Dim TransparencyAttr2 As System.Drawing.Imaging.ImageAttributes = New System.Drawing.Imaging.ImageAttributes
        Dim g2 As Graphics = Graphics.FromImage(bmpDoubleBuffer)
        Dim dstRect2 = New Rectangle(ShowX, ShowY, GFX.Width, GFX.Height)
        TransparencyAttr2.SetColorKey(Color.Red, Color.Red)
        g2.DrawImage(GFX, dstRect2, 0, 0, GFX.Width, GFX.Height, GraphicsUnit.Pixel, TransparencyAttr2)

    End Sub

    Shared Sub FreezeGameForXSeconds(ByVal WaitDuration As Integer)

        'Pagoma tou paixnidiou apenergopoiontas ton kirios timer timer1
        'kai energopoiisi tou ksana meta apo WaitDuration deuterolepta
        'I sinartisi xrisimopoiei to Timer2

        Form1.Timer1.Enabled = False
        Form1.Timer2.Interval = WaitDuration * 1000
        Form1.Timer2.Enabled = True
    End Sub

    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        'Xrisi apokleistika apo tin FreezeGameForXSeconds
        Me.Timer2.Enabled = False
        Me.Timer1.Enabled = True
    End Sub

    Public Function BitmapStreamLoader(ByVal StreamName As String) As Bitmap

        ' Fortosi enos stream grafikon se ena antikeimeno bitmap
        ' PROSOXI STIN STATHERA ProjectName na einai to onoma tou project!

        Dim TempStream As System.IO.Stream = Me.GetType().Assembly.GetManifestResourceStream((Trim(ProjectName) + "." + StreamName))
        Return New Bitmap(TempStream)
    End Function

    Shared Function ObjRandomizer(ByVal RandMin As Integer, ByVal RandMax As Integer)

        ' Mia random timi se orismeno euros

        Return Form1.r.Next(RandMin, RandMax + 1)

    End Function

    Public MustInherit Class GameObject

        'I kirios klasi pano stin opoia stithikan ta antikeimena tou paixnidiou

        Public ObjImage As Bitmap
        Public MinX, MaxX, ObjX, ObjStepX As Integer
        Public MinY, MaxY, ObjY, ObjStepY As Integer
        Public ObjWidth, ObjHeight As Integer
        Public IsAlive As Boolean
        Public ObjSpeed, ObjMinSpeed, ObjMaxSpeed As Integer
        Public dstRect As Rectangle
        Public TransparencyAttr As System.Drawing.Imaging.ImageAttributes = New System.Drawing.Imaging.ImageAttributes

        Public Sub New(ByVal AnObjImage As Bitmap, ByVal AnObjX As Integer, ByVal AnObjY As Integer, ByVal AnMinX As Integer, ByVal AnMinY As Integer, ByVal AnMaxX As Integer, ByVal AnMaxY As Integer, ByVal AnObjMinSpeed As Integer, ByVal AnObjMaxSpeed As Integer)

            ObjImage = AnObjImage
            ObjX = AnObjX
            ObjY = AnObjY
            MinX = AnMinX
            MinY = AnMinY
            MaxX = AnMaxX - ObjImage.Width
            MaxY = AnMaxY - ObjImage.Height
            ObjMinSpeed = AnObjMinSpeed
            ObjMaxSpeed = AnObjMaxSpeed
            ObjSpeed = ObjRandomizer(ObjMinSpeed, ObjMaxSpeed)
            ObjStepX = ObjSpeed
            ObjStepY = ObjSpeed
            
            ObjWidth = ObjImage.Width
            ObjHeight = ObjImage.Height
            IsAlive = False

        End Sub

        Public MustOverride Sub PositionUpdate()

        Public Overridable Sub BoundCheck()
            If ObjX >= MaxX Then ObjX = MaxX
            If ObjY >= MaxY Then ObjY = MaxY

            If ObjX <= MinX Then ObjX = MinX
            If ObjY <= MinY Then ObjY = MinY
        End Sub

        Public Overridable Sub DrawObject()

            Dim g As Graphics = Graphics.FromImage(bmpDoubleBuffer)

            dstRect = New Rectangle(ObjX, ObjY, ObjImage.Width, ObjImage.Height)
            TransparencyAttr.SetColorKey(Color.Red, Color.Red)
            g.DrawImage(ObjImage, dstRect, 0, 0, ObjImage.Width, ObjImage.Height, GraphicsUnit.Pixel, TransparencyAttr)

        End Sub

    End Class

    Public MustInherit Class GameObjectAnimated
        Public ObjImageArray(9) As Bitmap
        Public MinX, MaxX, ObjX, ObjStepX As Integer
        Public MinY, MaxY, ObjY, ObjStepY As Integer
        Public ObjWidth, ObjHeight As Integer
        Public IsAlive As Boolean
        Public ObjSpeed, ObjMinSpeed, ObjMaxSpeed As Integer
        Public dstRect As Rectangle
        Public TransparencyAttr As System.Drawing.Imaging.ImageAttributes = New System.Drawing.Imaging.ImageAttributes
        Public AnimationCounterNormal, AnimationCounterExplosion, AnimationCounterDamaged As Integer
        Public ObjAnimation As AnimationStatus

        Public Sub New(ByVal AnObjImageArray() As Bitmap, ByVal AnObjX As Integer, ByVal AnObjY As Integer, ByVal AnMinX As Integer, ByVal AnMinY As Integer, ByVal AnMaxX As Integer, ByVal AnMaxY As Integer, ByVal AnObjMinSpeed As Integer, ByVal AnObjMaxSpeed As Integer)

            ObjImageArray = AnObjImageArray
            ObjX = AnObjX
            ObjY = AnObjY
            MinX = AnMinX
            MinY = AnMinY
            MaxX = AnMaxX - ObjImageArray(0).Width
            MaxY = AnMaxY - ObjImageArray(0).Height
            ObjSpeed = ObjRandomizer(AnObjMinSpeed, AnObjMaxSpeed)
            ObjStepX = ObjSpeed
            ObjStepY = ObjSpeed
            ObjMinSpeed = AnObjMinSpeed
            ObjMaxSpeed = AnObjMaxSpeed
            ObjWidth = ObjImageArray(0).Width
            ObjHeight = ObjImageArray(0).Height
            IsAlive = False
            AnimationCounterNormal = 0
            AnimationCounterExplosion = 0
            AnimationCounterDamaged = 0
            ObjAnimation = AnimationStatus.Normal

        End Sub

        Public MustOverride Sub PositionUpdate()

        Public Overridable Sub BoundCheck()
            If ObjX >= MaxX Then ObjX = MaxX
            If ObjY >= MaxY Then ObjY = MaxY

            If ObjX <= MinX Then ObjX = MinX
            If ObjY <= MinY Then ObjY = MinY
        End Sub

        Public Overridable Sub DrawObject()
            Dim DisplayFrameNumber As Integer

            If ObjAnimation = AnimationStatus.Normal Then
                DisplayFrameNumber = AnimationCounterNormal / GameFPS
                AnimationCounterNormal += 4
                If AnimationCounterNormal > (GameFPS * 3) Then AnimationCounterNormal = 0
            End If

            If ObjAnimation = AnimationStatus.Explosion Then
                DisplayFrameNumber = (AnimationCounterExplosion / GameFPS) + 4
                AnimationCounterExplosion += 12
                If AnimationCounterExplosion > (GameFPS * 3) Then
                    AnimationCounterExplosion = 0
                    ObjAnimation = AnimationStatus.Normal
                    IsAlive = False
                End If
            End If

            If ObjAnimation = AnimationStatus.Damage Then
                DisplayFrameNumber = (AnimationCounterDamaged / GameFPS) + 8
                AnimationCounterDamaged += 12
                If AnimationCounterDamaged > (GameFPS * 3) Then
                    AnimationCounterDamaged = 0
                    ObjAnimation = AnimationStatus.Normal

                End If
            End If

            Dim g As Graphics = Graphics.FromImage(bmpDoubleBuffer)

            dstRect = New Rectangle(ObjX, ObjY, ObjImageArray(0).Width, ObjImageArray(0).Height)
            TransparencyAttr.SetColorKey(Color.Red, Color.Red)
            g.DrawImage(ObjImageArray(DisplayFrameNumber), dstRect, 0, 0, ObjImageArray(0).Width, ObjImageArray(0).Height, GraphicsUnit.Pixel, TransparencyAttr)

        End Sub

    End Class

    Public Class GameLevel

        Public UFOProperties, AlienProperties, MeteoriteProperties As EnemyProperties
        Public UFOArray(MAXIMUMENEMYPERTYPE), AliensArray(MAXIMUMENEMYPERTYPE) As EnemyObject
        Public MeteoritesArray(MAXIMUMENEMYPERTYPE) As MeteoriteObject
        Public IntroSplash As Bitmap
        Public IntroSplashShown As Boolean
        Public MissionKills, KillsCount As Integer
        Public InitedOnce As Boolean = False
        Public LevelBackground As Bitmap
        Public IncreasedLevelOnce As Boolean = False

        Public MissionAccomplished As Boolean = False

        Public Sub New(ByVal A_IntroSplash As Bitmap, ByVal A_LevelBackground As Bitmap, ByVal A_MissionKills As Integer, ByVal A_UFOProperties As EnemyProperties, ByVal A_AlienProperties As EnemyProperties, ByVal A_MeteoriteProperties As EnemyProperties)

            IntroSplash = A_IntroSplash
            MissionKills = A_MissionKills
            UFOProperties = A_UFOProperties
            AlienProperties = A_AlienProperties
            MeteoriteProperties = A_MeteoriteProperties
            LevelBackground = A_LevelBackground

            Init()

        End Sub

        Public Sub Init()
            'Dimiourgia Aliens
            If AlienProperties.Enabled Then
                For i As Integer = 0 To AlienProperties.EnemyCount - 1
                    AliensArray(i) = New EnemyObject(AlienProperties.EnemyAnimation, AlienProperties.EnemyX, AlienProperties.EnemyY, AlienProperties.EnemyMinX, AlienProperties.EnemyMinY, AlienProperties.EnemyMaxX, AlienProperties.EnemyMaxY, AlienProperties.EnemyMinSpeed, AlienProperties.EnemyMaxSpeed, AlienProperties.EnemyAgressiveness, AlienProperties.EnemyFireNum, AlienProperties.EnemyLaserDamage, AlienProperties.EnemyCollisionDamage)
                    AliensArray(i).IsAlive = True
                Next i
            End If

            'Dimiourgia UFO
            If UFOProperties.Enabled Then
                For i As Integer = 0 To UFOProperties.EnemyCount - 1
                    UFOArray(i) = New EnemyObject(UFOProperties.EnemyAnimation, UFOProperties.EnemyX, UFOProperties.EnemyY, UFOProperties.EnemyMinX, UFOProperties.EnemyMinY, UFOProperties.EnemyMaxX, UFOProperties.EnemyMaxY, UFOProperties.EnemyMinSpeed, UFOProperties.EnemyMaxSpeed, UFOProperties.EnemyAgressiveness, UFOProperties.EnemyFireNum, UFOProperties.EnemyLaserDamage, UFOProperties.EnemyCollisionDamage)
                    UFOArray(i).IsAlive = True
                Next i
            End If

            'Dimiourgia Meteorites
            If MeteoriteProperties.Enabled Then
                For i As Integer = 0 To MeteoriteProperties.EnemyCount - 1
                    MeteoritesArray(i) = New MeteoriteObject(MeteoriteProperties.EnemyAnimation, MeteoriteProperties.EnemyX, MeteoriteProperties.EnemyY, MeteoriteProperties.EnemyMinX, MeteoriteProperties.EnemyMinY, MeteoriteProperties.EnemyMaxX, MeteoriteProperties.EnemyMaxY, MeteoriteProperties.EnemyMinSpeed, MeteoriteProperties.EnemyMaxSpeed, MeteoriteProperties.EnemyCollisionDamage)
                    MeteoritesArray(i).IsAlive = True
                Next
            End If

            KillsCount = 0
            MissionAccomplished = False
            IntroSplashShown = False

            IncreasedLevelOnce = False







        End Sub

        Public Sub Update()

            If Not InitedOnce Then

                CurrentBackground = LevelBackground

                Energy.IsAlive = False
                Player.Health = PlayerMaxHealth
                Player.ObjX = ((Form1.Width / 2) - (Player.ObjWidth / 2))
                Player.ObjY = Player.MaxY
                Player.ObjAnimation = AnimationStatus.Normal

                For i As Integer = 0 To PlayerLaserNum - 1
                    PlayerLaserShots(i).IsAlive = False
                Next

                LevelProgress = 0
                LevelProgressSTEP = (50 / MissionKills)
                InitedOnce = True
                Init()
            End If


            ' Sxediasi tou background sto buffer
            Dim g As Graphics = Graphics.FromImage(bmpDoubleBuffer)
            g.DrawImage(LevelBackground, 0, 0)


            If Not IntroSplashShown Then
                ShowGFXCentered(IntroSplash)
                Form1.Invalidate()
                FreezeGameForXSeconds(3)
                IntroSplashShown = True
            Else


                ' Meteorites
                If MeteoriteProperties.Enabled Then
                    For i As Integer = 0 To MeteoriteProperties.EnemyCount - 1

                        MeteoritesArray(i).CollisionCheck()
                        MeteoritesArray(i).PositionUpdate()

                        If MeteoritesArray(i).IsAlive = True Then MeteoritesArray(i).DrawObject()

                        For j As Integer = 0 To MeteoriteProperties.EnemyCount - 1

                            If MeteoritesArray(j).IsAlive = False And Not MissionAccomplished Then MeteoritesArray(j).InitObject()

                        Next

                    Next

                End If



                ' Aliens

                If AlienProperties.Enabled Then

                    For i As Integer = 0 To AlienProperties.EnemyCount - 1

                        AliensArray(i).CollisionCheck()
                        AliensArray(i).PositionUpdate()

                        If AliensArray(i).IsAlive = True Then AliensArray(i).DrawObject()
                        If AliensArray(i).IsAlive = False And AliensArray(i).MissilesActive = False Then KillsCount += 1
                        If AliensArray(i).IsAlive = False And Not AliensArray(i).MissilesActive And Not MissionAccomplished Then AliensArray(i).InitObject()

                    Next i

                End If

                If UFOProperties.Enabled Then

                    For i As Integer = 0 To UFOProperties.EnemyCount - 1

                        UFOArray(i).CollisionCheck()
                        UFOArray(i).PositionUpdate()

                        If UFOArray(i).IsAlive = True Then UFOArray(i).DrawObject()
                        If UFOArray(i).IsAlive = False And UFOArray(i).MissilesActive = False Then KillsCount += 1
                        If UFOArray(i).IsAlive = False And Not UFOArray(i).MissilesActive And Not MissionAccomplished Then UFOArray(i).InitObject()

                    Next i

                End If

                If KillsCount >= MissionKills Then MissionAccomplished = True



                'To bonus energy

                If Energy.IsAlive Then
                    Energy.CollisionCheck()
                    Energy.PositionUpdate()
                    Energy.DrawObject()
                End If


                ' Mission Accomplished

                If MissionAccomplished Then

                    ShowGFXCentered(MissionAccomplishedBMP)


                    If Not IncreasedLevelOnce Then
                        IncreasedLevelOnce = True
                        FreezeGameForXSeconds(3)

                        CurrentLevel += 1

                        InitedOnce = False



                    End If



                End If

            End If

        End Sub

    End Class

    Public Class PlayerObject
        Inherits GameObjectAnimated
        Public MaxHealth As Integer = PlayerMaxHealth
        Public Health As Integer = MaxHealth
        Dim UpFlag As Boolean = False
        Dim DownFlag As Boolean = False
        Dim LeftFlag As Boolean = False
        Dim RightFlag As Boolean = False


        Sub New(ByVal AnObjImageArray() As Bitmap, ByVal AnObjX As Integer, ByVal AnObjY As Integer, ByVal AnMinX As Integer, ByVal AnMinY As Integer, ByVal AnMaxX As Integer, ByVal AnMaxY As Integer, ByVal AnObjMinSpeed As Integer, ByVal AnObjMaxSpeed As Integer)
            MyBase.New(AnObjImageArray, AnObjX, AnObjY, AnMinX, AnMinY, AnMaxX, AnMaxY, AnObjMinSpeed, AnObjMaxSpeed)
            IsAlive = True
        End Sub

        Public Overrides Sub PositionUpdate()

            Select Case (KeyFlag)

                Case Directions.GoUp
                    UpFlag = True
                    DownFlag = False
                    LeftFlag = False
                    RightFlag = False

                Case Directions.GoDown
                    DownFlag = True
                    UpFlag = False
                    LeftFlag = False
                    RightFlag = False

                Case Directions.GoLeft
                    LeftFlag = True
                    RightFlag = False
                    UpFlag = False
                    DownFlag = False

                Case Directions.GoRight
                    RightFlag = True
                    LeftFlag = False
                    UpFlag = False
                    DownFlag = False

                Case Directions.GoUpStop
                    UpFlag = False
                Case Directions.GoDownStop
                    DownFlag = False
                Case Directions.GoLeftStop
                    LeftFlag = False
                Case Directions.GoRightStop
                    RightFlag = False

            End Select

            If UpFlag Then ObjY -= ObjSpeed
            If DownFlag Then ObjY += ObjSpeed
            If LeftFlag Then ObjX -= ObjSpeed
            If RightFlag Then ObjX += ObjSpeed

            BoundCheck()

        End Sub

        Public Sub PlayerStatus()

            If IsAlive = False Then GameOver = True

            Form1.ShowGFXAtXY(EnergyTextBMP, 1, Form1.Height - EnergyTextBMP.Height - 1)
            Form1.ShowGFXAtXY(MissionTextBMP, 1, Form1.Height - EnergyTextBMP.Height - MissionTextBMP.Height - 1)

            Dim g As Graphics = Graphics.FromImage(bmpDoubleBuffer)

            TransparencyAttr.SetColorKey(Color.Black, Color.Black)

            For i As Integer = 1 To 50

                dstRect = New Rectangle(((BlueBar.Width + 1) * (i)) + EnergyTextBMP.Width, Form1.Height - (BlueBar.Height * 2) - 1, BlueBar.Width, 9)

                If i > LevelProgress Then
                    g.DrawImage(GreyBar, dstRect, 0, 0, GreyBar.Width, GreyBar.Height, GraphicsUnit.Pixel, TransparencyAttr)
                Else
                    g.DrawImage(BlueBar, dstRect, 0, 0, BlueBar.Width, BlueBar.Height, GraphicsUnit.Pixel, TransparencyAttr)
                End If
            Next i

            For i As Integer = 1 To MaxHealth

                dstRect = New Rectangle(((RedBar.Width + 1) * (i)) + EnergyTextBMP.Width, Form1.Height - RedBar.Height - 1, RedBar.Width, 9)

                If i > Health Then
                    g.DrawImage(RedBar, dstRect, 0, 0, RedBar.Width, RedBar.Height, GraphicsUnit.Pixel, TransparencyAttr)
                Else
                    g.DrawImage(GreenBar, dstRect, 0, 0, GreenBar.Width, GreenBar.Height, GraphicsUnit.Pixel, TransparencyAttr)
                End If

            Next i

            If Health <= 0 Then
                ObjAnimation = AnimationStatus.Explosion
            End If

        End Sub

    End Class

    Public Class EnemyMissile
        Inherits GameObject

        Public DamageFromEnemyLaser As Integer

        Sub New(ByVal AnObjImage As Bitmap, ByVal AnObjX As Integer, ByVal AnObjY As Integer, ByVal AnMinX As Integer, ByVal AnMinY As Integer, ByVal AnMaxX As Integer, ByVal AnMaxY As Integer, ByVal AnObjMinSpeed As Integer, ByVal AnObjMaxSpeed As Integer, ByVal A_DamageFromEnemyLaser As Integer)
            MyBase.New(AnObjImage, AnObjX, AnObjY, AnMinX, AnMinY, AnMaxX, AnMaxY, AnObjMinSpeed, AnObjMaxSpeed)

            DamageFromEnemyLaser = A_DamageFromEnemyLaser

        End Sub

        Public Overrides Sub PositionUpdate()
            ObjY += ObjSpeed
            BoundCheck()



        End Sub

        Public Overrides Sub BoundCheck()
           
            If ObjY > MaxY Then IsAlive = False



            If ((Player.ObjX + Player.ObjWidth > ObjX) And (Player.ObjX < ObjX + ObjWidth)) And ((Player.ObjY + Player.ObjHeight > ObjY) And (Player.ObjY < ObjY + ObjHeight)) Then

                Player.Health -= DamageFromEnemyLaser
                Player.ObjAnimation = AnimationStatus.Damage
                IsAlive = False

               

            End If

        End Sub

    End Class

    Public Class PlayerMissile
        Inherits GameObject

        Sub New(ByVal AnObjImage As Bitmap, ByVal AnObjX As Integer, ByVal AnObjY As Integer, ByVal AnMinX As Integer, ByVal AnMinY As Integer, ByVal AnMaxX As Integer, ByVal AnMaxY As Integer, ByVal AnObjMinSpeed As Integer, ByVal AnObjMaxSpeed As Integer)

            MyBase.New(AnObjImage, AnObjX, AnObjY, AnMinX, AnMinY, AnMaxX, AnMaxY, AnObjMinSpeed, AnObjMaxSpeed)

        End Sub

        Public Overrides Sub PositionUpdate()

            If IsAlive = True Then ObjY -= ObjSpeed

            If IsAlive = False And KeyFlag = Directions.Fire Then

                IsAlive = True
                ObjX = Form1.Player.ObjX + ((Form1.Player.ObjImageArray(0).Width) / 2) - 2
                ObjY = Form1.Player.ObjY - ObjImage.Height + ObjSpeed
                KeyFlag = Directions.NullDirection_FireException


            End If



            BoundCheck()

        End Sub

        

        Public Overrides Sub BoundCheck()

            If ObjY <= MinY Then IsAlive = False

        End Sub

    End Class

    Public Class StarObject
        Inherits GameObject

        Sub New(ByVal AnObjImage As Bitmap, ByVal AnObjX As Integer, ByVal AnObjY As Integer, ByVal AnMinX As Integer, ByVal AnMinY As Integer, ByVal AnMaxX As Integer, ByVal AnMaxY As Integer, ByVal AnObjMinSpeed As Integer, ByVal AnObjMaxSpeed As Integer)
            MyBase.New(AnObjImage, AnObjX, AnObjY, AnMinX, AnMinY, AnMaxX, AnMaxY, AnObjMinSpeed, AnObjMaxSpeed)

            ObjX = ObjRandomizer(MinX, MaxX)
            ObjY = ObjRandomizer(MinY, MaxY)
            ObjSpeed = ObjRandomizer(AnObjMinSpeed, AnObjMaxSpeed)

        End Sub

        Public Overrides Sub PositionUpdate()
            ObjY += ObjSpeed
            BoundCheck()


        End Sub

        Public Overrides Sub BoundCheck()

            If (ObjY >= MaxY) Then
                ObjY = MinY
                ObjX = ObjRandomizer(MinX, MaxX)
                ObjSpeed = ObjRandomizer(ObjMinSpeed, ObjMaxSpeed)
            End If

        End Sub

    End Class

    Public Class EnemyObject
        Inherits GameObjectAnimated

        Public MissilesActive As Boolean = False

        Dim AlienLaserShots(MAXIMUMLASERPERTYPE) As EnemyMissile
        Dim AlienLaserBMP As Bitmap = Form1.BitmapStreamLoader("AlienLaser0.bmp")  'Alien's Laser bitmap
        Dim KillCounted As Boolean = False
        Dim CollisionCounted As Boolean = False
        Dim ObjAggressiveness, ObjLaserNum As Integer
        Public DamageFromLaser, DamageFromCollision As Integer



        Sub New(ByVal AnObjImageArray() As Bitmap, ByVal AnObjX As Integer, ByVal AnObjY As Integer, ByVal AnMinX As Integer, ByVal AnMinY As Integer, ByVal AnMaxX As Integer, ByVal AnMaxY As Integer, ByVal AnObjMinSpeed As Integer, ByVal AnObjMaxSpeed As Integer, ByVal A_Agressiveness As Integer, ByVal A_LaserNum As Integer, ByVal A_DamageFromLaser As Integer, ByVal A_DamageFromCollision As Integer)
            MyBase.New(AnObjImageArray, AnObjX, AnObjY, AnMinX, AnMinY, AnMaxX, AnMaxY, AnObjMinSpeed, AnObjMaxSpeed)

            ObjAggressiveness = A_Agressiveness
            ObjLaserNum = A_LaserNum
            DamageFromLaser = A_DamageFromLaser
            DamageFromCollision = A_DamageFromCollision
            InitObject()

        End Sub

        Public Sub InitObject()

            KillCounted = False
            CollisionCounted = False
            ObjSpeed = ObjRandomizer(ObjMinSpeed, ObjMaxSpeed)

            ObjX = ObjRandomizer(MinX, MaxX)
            ObjY = 0

            If Int(ObjRandomizer(0, 1)) = 1 Then ObjStepX = -ObjSpeed
            If Int(ObjRandomizer(0, 1)) = 1 Then ObjStepY = -ObjSpeed

            For i As Integer = 0 To ObjLaserNum - 1
                AlienLaserShots(i) = New EnemyMissile(AlienLaserBMP, 0, 0, 0, 0, Form1.Width, Form1.Height - AlienLaserBMP.Height, 5, 5, DamageFromLaser)
            Next i

            IsAlive = True

        End Sub

        Public Overrides Sub PositionUpdate()
            Dim AMissileAlive As Boolean = False
            Dim i As Integer = 0
            If IsAlive = True Then

                ' Bounce stin othoni
                If (ObjX + ObjStepX) > MaxX Then ObjStepX = -(ObjSpeed)
                If (ObjY + ObjStepY) > MaxY Then ObjStepY = -(ObjSpeed)

                If ObjX <= MinX Then ObjStepX = ObjSpeed
                If ObjY <= MinY Then ObjStepY = ObjSpeed

                ObjX += ObjStepX
                ObjY += ObjStepY

                BoundCheck() ' Gia sigouria ;)

                ' alien laser routina
                For i = 0 To ObjLaserNum - 1

                     

                    If (ObjRandomizer(0, 1000) < ObjAggressiveness) And AlienLaserShots(i).IsAlive = False Then

                        AlienLaserShots(i).ObjX = ObjX + (ObjWidth / 2)
                        AlienLaserShots(i).ObjY = ObjY + ObjHeight
                        AlienLaserShots(i).IsAlive = True
                        MissilesActive = True

                    End If
                Next

            End If

            AMissileAlive = False
            If MissilesActive = True Then
                For i = 0 To ObjLaserNum - 1
                    If AlienLaserShots(i).IsAlive = True Then
                        AlienLaserShots(i).PositionUpdate()
                        AlienLaserShots(i).DrawObject()
                        AMissileAlive = True
                    End If

                Next
            End If

            MissilesActive = AMissileAlive
        End Sub

        Public Sub CollisionCheck()

            If IsAlive = True Then



                For i As Integer = 0 To PlayerLaserNum - 1

                    If PlayerLaserShots(i).IsAlive = True Then


                        If PlayerLaserShots(i).IsAlive = True Then

                            If ((PlayerLaserShots(i).ObjX + PlayerLaserShots(i).ObjWidth > ObjX) And (PlayerLaserShots(i).ObjX < ObjX + ObjWidth)) And ((PlayerLaserShots(i).ObjY + PlayerLaserShots(i).ObjHeight > ObjY) And (PlayerLaserShots(i).ObjY < ObjY + ObjHeight)) Then

                                ObjAnimation = AnimationStatus.Explosion
                                If KillCounted = False Then
                                    LevelProgress += LevelProgressSTEP
                                    KillCounted = True

                                End If


                                If (ObjRandomizer(0, 100) < EnergyPossibility) And Energy.IsAlive = False Then

                                    Energy.ObjX = ObjX
                                    Energy.ObjY = ObjY
                                    Energy.IsAlive = True
                                End If

                                PlayerLaserShots(i).IsAlive = False

                            End If



                        End If
                    End If
                Next

                ' Sigkrousi metaksi paikti kai exthrou
                If ((Player.ObjX + Player.ObjWidth > ObjX) And (Player.ObjX < ObjX + ObjWidth)) And ((Player.ObjY + Player.ObjHeight > ObjY) And (Player.ObjY < ObjY + ObjHeight)) Then

                    If Not Player.ObjAnimation = AnimationStatus.Explosion Then Player.ObjAnimation = AnimationStatus.Damage
                    ObjAnimation = AnimationStatus.Explosion

                    If CollisionCounted = False Then
                        Player.Health -= DamageFromCollision
                        LevelProgress += LevelProgressSTEP
                        CollisionCounted = True

                    End If


                End If

            End If

        End Sub

    End Class

    Public Class MeteoriteObject
        Inherits GameObjectAnimated

        Public DamageFromCollision As Integer

        Sub New(ByVal AnObjImageArray() As Bitmap, ByVal AnObjX As Integer, ByVal AnObjY As Integer, ByVal AnMinX As Integer, ByVal AnMinY As Integer, ByVal AnMaxX As Integer, ByVal AnMaxY As Integer, ByVal AnObjMinSpeed As Integer, ByVal AnObjMaxSpeed As Integer, ByVal A_DamageFromCollision As Integer)
            MyBase.New(AnObjImageArray, AnObjX, AnObjY, AnMinX, AnMinY, AnMaxX, AnMaxY, AnObjMinSpeed, AnObjMaxSpeed)

            DamageFromCollision = A_DamageFromCollision
            InitObject()

        End Sub

        Public Overrides Sub PositionUpdate()


            If IsAlive = True Then

                ObjY += ObjStepY
                ObjX += ObjStepX

                BoundCheck() ' Gia sigouria ;)






            End If


        End Sub

        Public Sub InitObject()

            ObjSpeed = ObjRandomizer(ObjMinSpeed, ObjMaxSpeed)
            ObjX = ObjRandomizer(MinX, MaxX)
            ObjY = 0

            ObjStepY = ObjRandomizer(ObjMinSpeed, ObjMaxSpeed)
            ObjStepX = ObjRandomizer(0, 2)
            If Int(ObjRandomizer(0, 1)) = 1 Then ObjStepX = -ObjStepX




            IsAlive = True

        End Sub

        Public Sub CollisionCheck()

            If IsAlive = True Then

               
                For i As Integer = 0 To PlayerLaserNum - 1

                    If PlayerLaserShots(i).IsAlive = True Then

                        If PlayerLaserShots(i).IsAlive = True Then

                            If ((PlayerLaserShots(i).ObjX + PlayerLaserShots(i).ObjWidth > ObjX) And (PlayerLaserShots(i).ObjX < ObjX + ObjWidth)) And ((PlayerLaserShots(i).ObjY + PlayerLaserShots(i).ObjHeight > ObjY) And (PlayerLaserShots(i).ObjY < ObjY + ObjHeight)) Then

                                ObjAnimation = AnimationStatus.Explosion
                                PlayerLaserShots(i).IsAlive = False

                            End If
                        End If
                    End If
                Next

                If ((Player.ObjX + Player.ObjWidth > ObjX) And (Player.ObjX < ObjX + ObjWidth)) And ((Player.ObjY + Player.ObjHeight > ObjY) And (Player.ObjY < ObjY + ObjHeight)) Then
                    Player.Health -= DamageFromCollision
                    If Not Player.ObjAnimation = AnimationStatus.Explosion Then Player.ObjAnimation = AnimationStatus.Damage
                    ObjAnimation = AnimationStatus.Explosion
                    IsAlive = False
                End If


            End If

        End Sub

        Public Overrides Sub BoundCheck()

            If (ObjY >= MaxY) Or (ObjX >= MaxX) Or (ObjX <= MinX) Then
                ObjY = 0
                ObjX = ObjRandomizer(MinX, MaxX)
                ObjStepY = ObjRandomizer(ObjMinSpeed, ObjMaxSpeed)
                ObjStepX = ObjRandomizer(0, 2)
                If Int(ObjRandomizer(0, 1)) = 1 Then ObjStepX = -ObjSpeed
            End If



        End Sub

    End Class

    Public Class BonusObject
        Inherits GameObjectAnimated
        Sub New(ByVal AnObjImageArray() As Bitmap, ByVal AnObjX As Integer, ByVal AnObjY As Integer, ByVal AnMinX As Integer, ByVal AnMinY As Integer, ByVal AnMaxX As Integer, ByVal AnMaxY As Integer, ByVal AnObjMinSpeed As Integer, ByVal AnObjMaxSpeed As Integer)
            MyBase.New(AnObjImageArray, AnObjX, AnObjY, AnMinX, AnMinY, AnMaxX, AnMaxY, AnObjMinSpeed, AnObjMaxSpeed)
            InitObject()

        End Sub

        Public Sub InitObject()

            ObjX = ObjRandomizer(MinX, MaxX)
            ObjY = 0

            ObjStepY = ObjRandomizer(ObjMinSpeed, ObjMaxSpeed)


            IsAlive = False

        End Sub

        Public Overrides Sub PositionUpdate()
            If IsAlive = True Then

                ObjY += ObjStepY


                BoundCheck() ' Gia sigouria ;)






            End If
        End Sub

        Public Overrides Sub BoundCheck()

            If (ObjY >= MaxY) Or (ObjX >= MaxX) Or (ObjX <= MinX) Then

                IsAlive = False
                

            End If



        End Sub

        Public Sub CollisionCheck()



            If ((Player.ObjX + Player.ObjWidth > ObjX) And (Player.ObjX < ObjX + ObjWidth)) And ((Player.ObjY + Player.ObjHeight > ObjY) And (Player.ObjY < ObjY + ObjHeight)) Then
                Player.Health += EnergyBonus
                If Player.Health > Player.MaxHealth Then Player.Health = Player.MaxHealth
                Player.ObjAnimation = AnimationStatus.Damage
                IsAlive = False
            End If




        End Sub

    End Class

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        CustomUFOProperties.Enabled = CheckBox1.Checked
        CustomUFOProperties.EnemyAgressiveness = TrackBar2.Value

        CustomUFOProperties.EnemyCollisionDamage = 10
        CustomUFOProperties.EnemyCount = TrackBar1.Value
        CustomUFOProperties.EnemyFireNum = 2
        CustomUFOProperties.EnemyLaserDamage = 5
        CustomUFOProperties.EnemyMaxSpeed = 3
        CustomUFOProperties.EnemyMaxX = Me.Width
        CustomUFOProperties.EnemyMaxY = Me.Height / 1.5
        CustomUFOProperties.EnemyMinSpeed = 2
        CustomUFOProperties.EnemyMinX = 0
        CustomUFOProperties.EnemyMinY = 0
        CustomUFOProperties.EnemyX = 0  '  
        CustomUFOProperties.EnemyY = 0  '  


        CustomAlienProperties.Enabled = CheckBox2.Checked
        CustomAlienProperties.EnemyAgressiveness = TrackBar3.Value

        CustomAlienProperties.EnemyCollisionDamage = 10
        CustomAlienProperties.EnemyCount = TrackBar4.Value
        CustomAlienProperties.EnemyFireNum = 2
        CustomAlienProperties.EnemyLaserDamage = 5
        CustomAlienProperties.EnemyMaxSpeed = 5
        CustomAlienProperties.EnemyMaxX = Me.Width
        CustomAlienProperties.EnemyMaxY = Me.Height / 1.5
        CustomAlienProperties.EnemyMinSpeed = 3
        CustomAlienProperties.EnemyMinX = 0
        CustomAlienProperties.EnemyMinY = 0
        CustomAlienProperties.EnemyX = 0  '  
        CustomAlienProperties.EnemyY = 0  '  


        CustomMeteoriteProperties.Enabled = CheckBox3.Checked
        CustomMeteoriteProperties.EnemyAgressiveness = 0

        CustomMeteoriteProperties.EnemyCollisionDamage = 10
        CustomMeteoriteProperties.EnemyCount = TrackBar6.Value
        CustomMeteoriteProperties.EnemyFireNum = 0
        CustomMeteoriteProperties.EnemyLaserDamage = 0
        CustomMeteoriteProperties.EnemyMaxSpeed = TrackBar5.Value
        CustomMeteoriteProperties.EnemyMaxX = Me.Width
        CustomMeteoriteProperties.EnemyMaxY = Me.Height
        CustomMeteoriteProperties.EnemyMinSpeed = TrackBar5.Minimum
        CustomMeteoriteProperties.EnemyMinX = 0
        CustomMeteoriteProperties.EnemyMinY = 0
        CustomMeteoriteProperties.EnemyX = 0  '  
        CustomMeteoriteProperties.EnemyY = 0  '  

        CustomKillsCount = TrackBar7.Value
        Panel1.Enabled = False
        Panel1.Hide()

        Me.Focus()

        Init()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        CUSTOM_LEVEL_MODE = False
        Panel1.Enabled = False
        Panel1.Hide()

        Me.Focus()
        Timer1.Enabled = True
        Init()
    End Sub


End Class

